from concurrent import futures
import time


def test(sleep_time, fail=False):
    """Simple async function"""
    time.sleep(sleep_time)
    if fail:
        raise RuntimeError('failing as asked')
    return True


def main():
    executor = futures.ThreadPoolExecutor(max_workers=1)
    future1 = executor.submit(test, 0.6)
    future2 = executor.submit(test, 0.4, True)
    while future2.running() or future1.running():
        for num, future in [(1, future1), (2, future2)]:
            if future.running():
                try:
                    r1 = future.result(timeout=0.1)
                    print(r1)
                except RuntimeError:
                    print('future %d threw an error' % num)
                except futures.TimeoutError:
                    print('future %d still running' % num)

if __name__ == '__main__':
    main()
