from concurrent import futures
import time


def test(sleep_time, fail=False):
    """Simple async function"""
    time.sleep(sleep_time)
    print('still running')
    if fail:
        raise RuntimeError('failing as asked')
    return True


def main():
    executor = futures.ThreadPoolExecutor(max_workers=2)
    future1 = executor.submit(test, 0.6)
    future2 = executor.submit(test, 0.4, True)
    future2.cancel()


if __name__ == '__main__':
    main()
